from keras.utils import plot_model
from keras.models import Model, load_model
from keras.layers import Input, Dense, LSTM, Embedding, Dropout
from keras.layers.merge import add

class Nic_model(object):
    def define_model(self,vocab_size , max_length):
        # features from the CNN model squeezed from 2048 to 256 nodes
        inputs1 = Input(shape=(2048,))
        fe1 = Dropout(0.5)(inputs1)
        fe2 = Dense(256, activation='relu')(fe1)
        # LSTM sequence model
        inputs2 = Input(shape=(max_length,))
        se1 = Embedding(vocab_size, output_dim=256, mask_zero=True)(inputs2)
        se2 = Dropout(0.5)(se1)
        se3 = LSTM(256)(se2)
        # Merging both models
        decoder1 = add([fe2, se3])
        decoder2 = Dense(256, activation='relu')(decoder1)
        outputs = Dense(vocab_size, activation='softmax')(decoder2)
        # tie it together [image, seq] [word]
        model = Model(inputs=[inputs1, inputs2], outputs=outputs)
        model.compile(loss='categorical_crossentropy', optimizer='adam',metrics=['accuracy'])
        # summarize model
        # print(model.summary())
        plot_model(model, to_file='model.png', show_shapes=True)
        return model
if __name__ == '__main__':
    nic_model = Nic_model()
    model = nic_model.define_model(7757,34)
