import tensorflow as tf
import os
from keras.models import Model, load_model
from keras import backend as K
def export_serving_model(version = 2,path='./serving_model/nic/'):
    model_path = os.path.join(
                    tf.compat.as_bytes(path),
                    tf.compat.as_bytes(str(version))
                 )
    model = load_model('./models/model_29.h5')
    print(model.input)
    with K.get_session() as sess:
        tf.saved_model.simple_save(
            session=sess,
            export_dir=model_path,
            inputs={'images': model.input[0],'start_seq':model.input[1]},#注意input和inputs的区别
            outputs={model.output.name:model.output}

        )

if __name__ == '__main__':
    export_serving_model()

    #docker run -p 8501:8501 -p 8500:8500 --mount type=bind,source=/Users/yangjiaji/Documents/python黑马/SSD网络物体检测/serving_model/commodity,target=/models/commodity -e MODEL_NAME=commodity -t tensorflow/serving
