from tensorflow_serving.apis import prediction_service_pb2_grpc
from tensorflow_serving.apis import predict_pb2
from tensorflow.python.saved_model import signature_constants
import io
from PIL import Image
import numpy as np
from keras.applications.xception import Xception, preprocess_input
import grpc
import tensorflow as tf
from pickle import dump,load
from keras.preprocessing.sequence import pad_sequences
import keras

def word_for_id(integer, tokenizer):
    for word, index in tokenizer.word_index.items():
         if index == integer:
             return word
    return None
def make_prediction(image):
    """
    对于前端传入的参数进行预测
    :return:
    """
    # - 1、获取读取后台读取的图片
    def resize_img(image, input_size):
        img = io.BytesIO()
        img.write(image)
        # 使用pillow image 接收这个图片
        rgb = Image.open(img).convert('RGB')

        # 换砖大小
        if input_size:
            rgb = rgb.resize((input_size[0], input_size[1]))

        return rgb

    # - 2、图片大小处理，转换数组
    image = resize_img(image, (299, 299))
    image = np.array(image)
    # for images that has 4 channels, we convert them into 3 channels
    if image.shape[2] == 4:
        image = image[..., :3]
    image = np.expand_dims(image, axis=0)
    image = image/127.5
    image = image - 1.0
    xception_model = Xception(include_top=False, pooling="avg")
    feature = xception_model.predict(image)
    tokenizer = load(open("tokenizer.p", "rb"))
    in_text = 'start'
    for i in range(34):
        # sequence = tokenizer.texts_to_sequences([in_text])[0]
        # sequence = pad_sequences([sequence], maxlen=max_length)
        # pred = model.predict([photo,sequence], verbose=0)
        # pred = np.argmax(pred)
        # word = word_for_id(pred, tokenizer)
        # if word is None:
        #     break
        # in_text += ' ' + word
        # if word == 'end':
        #     break
        sequence = tokenizer.texts_to_sequences([in_text])[0]
        sequence = pad_sequences([sequence], maxlen=34)
    # - 3、打开通道channel, 构建stub，预测结果， predict_pb2进行预测请求创建
    # 8500:grpc 8501:http

        with grpc.insecure_channel("127.0.0.1:8500") as channel:
            # stub通道
            stub = prediction_service_pb2_grpc.PredictionServiceStub(channel)

            # 构造请求 tensorflow serving请求格式
            request = predict_pb2.PredictRequest()
            request.model_spec.name = 'nic'
            # 默认签名即可
            request.model_spec.signature_name = signature_constants.DEFAULT_SERVING_SIGNATURE_DEF_KEY
            request.inputs['images'].CopyFrom(tf.make_tensor_proto(feature,shape=list(feature.shape)))
            request.inputs['start_seq'].CopyFrom(tf.make_tensor_proto(sequence, shape=list(sequence.shape),dtype=tf.float32))
            # 与模型服务进行请求获取预测结果
            # 模型服务的request {'concat_3:0': tensor类}
            keras.backend.clear_session()
            results = stub.Predict(request)

            # 会话去解析模型服务返回的结果
            with tf.Session() as sess:
                _res = sess.run(tf.convert_to_tensor(results.outputs['dense_3/Softmax:0']))
        pred = np.argmax(_res)
        word = word_for_id(pred, tokenizer)
        if word is None:
            break
        in_text += ' ' + word
        if word == 'end':
            break
    return in_text
if __name__ == '__main__':
    image = Image.open('./img.jpg')
    imgByteArr = io.BytesIO()
    image.save(imgByteArr, format='JPEG')
    imgByteArr = imgByteArr.getvalue()
    result = make_prediction(imgByteArr)
    print(result[6:-4])
